import de.bezier.data.sql.*;

/*
* Author - Ankit Srivastava
* 02.09.2012
* MAT 259 - Visualizing Information
* Homework 1 - Revisted.
*/

ArrayList monthArray;
ArrayList deweyArray;

String[] monthNames;
String[] deweyNames;

int currMonth = 0;

MySQL msql;
PFont font1;
int maxVal;
boolean showGrid = false;
int X = 1040;
int Y = 720;

int paddingLeft = 40;
int paddingRight = 20;
int paddingTop = 40;
int paddingBottom = 10;
int gridSpacing = 20;

void setup() {
  size(X,Y);
  frameRate(30);
  colorMode(HSB,360,100,100);
  textAlign(CENTER,CENTER);
  smooth();
  
  initializeMonthNames();
  initializeDeweyNames();
  fetchDatafromMysql();
}

void draw() {
  
  background(40,0,100);
  if(showGrid)
    drawGrid();
  Month m = (Month) monthArray.get(currMonth);
  //println(m.name);
  
  deweyArray = (ArrayList) m.deweyList;
  int counter = 0;

  font1 = loadFont("SansSerif.bold-14.vlw");
  textFont(font1);
  textAlign(RIGHT,CENTER);
  

  for(int i = 0; i< Y; i=i+3*gridSpacing){
    if(counter==10)
      break;
    Dewey d = (Dewey) deweyArray.get(counter);
    fill(180,100,40);
    noStroke();
    
    //ellipse(paddingLeft, i + paddingTop, 1.5*gridSpacing,1.5*gridSpacing);
    
    float booksLine = map(d.book,0,m.maxVal,0,800);
    float cdsLine = map(d.cd,0,m.maxVal,0,800);
    float dvdsLine = map(d.dvd,0,m.maxVal,0,800);
    
    fill(0,0,50);
    textAlign(LEFT, CENTER);
    if((mouseY > (i+paddingTop - 1.5*gridSpacing)) && (mouseY < (i+paddingTop + 1.5*gridSpacing)))
      text("Books :"+d.book+", CDs: "+d.cd+", DVDs: "+d.dvd +", Total: "+d.total,1.25*paddingLeft, i+paddingTop + 1.5*gridSpacing);
    textAlign(RIGHT,CENTER);
    strokeWeight(10);
    strokeCap(SQUARE);

    //drawLine1
    stroke(0,75,80);
    line(paddingLeft, i + paddingTop, paddingLeft + booksLine, i+paddingTop);

    //drawLine2
    stroke(180,100,60);
    line(paddingLeft + booksLine, i + paddingTop, paddingLeft + booksLine + cdsLine, i+paddingTop);

    //drawLine3
    stroke(40,75,80);
    line(paddingLeft + booksLine + cdsLine, i + paddingTop, paddingLeft + booksLine + cdsLine + dvdsLine, i+paddingTop);

    //line(paddingLeft, i + 40, 
    
    
    fill(0,0,50);
    text(d.name.toUpperCase(), X-paddingRight,i+40);
    counter++;
    
  }
  
  fill(180,100,40);
  strokeWeight(5);
  strokeCap(SQUARE);
  stroke(180,20,20);
  line(paddingLeft, gridSpacing, paddingLeft, 30*gridSpacing);
  
  
  strokeWeight(10);
  strokeCap(SQUARE);
  textAlign(LEFT, CENTER);
  fill(0, 0, 50);  

  stroke(180,100,60);
  line(X/2, Y-8*paddingBottom, X/2 + 2*gridSpacing, Y-8*paddingBottom);
  text("CDs", X/2 + 45,Y-8*paddingBottom);
  
  stroke(0,75,80);
  line(X/2 - 6*gridSpacing, Y-8*paddingBottom, X/2 - 4*gridSpacing, Y-8*paddingBottom);
  text("Books", X/2 - 4*gridSpacing + 5,Y-8*paddingBottom);
  
  stroke(40,75,80);
  line(X/2 + 6*gridSpacing, Y-8*paddingBottom, X/2 + 8*gridSpacing, Y-8*paddingBottom);
  text("DVDs", X/2 + 8*gridSpacing + 5,Y-8*paddingBottom);
  
  fill(0, 0, 50);
  textAlign(LEFT,BOTTOM);
  font1 = loadFont("SansSerif.plain-30.vlw");
  textFont(font1); 
  String s = "CHECKOUTS vs DEWEY CLASS - "+m.name.toUpperCase() +" 2011";
  text(s, X/6,Y-paddingBottom);
  
}

void mousePressed(){
  if(mouseButton == LEFT){
    if (currMonth < 11)
      currMonth++;
    else
      currMonth = 0;
  }
  else if(mouseButton == RIGHT){
    if (currMonth != 0)
      currMonth--;
  }
  println(currMonth);
  
}

void keyPressed() {
  if (key==' ')
    showGrid = !showGrid;
}
void drawGrid(){
  stroke(0,0,0);
  strokeWeight(0.5);
  for(int i = 0; i<=X; i += 20){
    line(i,0,i,Y);
  }
  for(int i = 0; i<=Y; i += 20){
    line(0,i,X,i);
  }
}
  
void initializeMonthNames() {
  DateFormatSymbols dfs = new DateFormatSymbols();
  monthNames = dfs.getMonths();
}

void initializeDeweyNames() {
  deweyNames = new String[10];
  String savedData[] = loadStrings("deweClass.txt");
  for (int i=0; i < savedData.length; i++) {
    String temp[] = split(savedData[i],"|");  
    deweyNames[i] = temp[1];
    //println( deweyNames[i]);
  }
}

String resolveDeweyName(String deweyClass) {
  
  String deweyName = deweyNames[(Integer.parseInt(deweyClass))/100];
  //println(deweyName);
  return deweyName;
}

void fetchDatafromMysql() {
  msql =  new MySQL(this, "tango.mat.ucsb.edu", "spl_years", "mat259", "V1sual1zat1on");
  monthArray = new ArrayList();
  if( msql.connect() ) {
    int monthIndex = 1;
    while(monthIndex <= 12){
      deweyArray = new ArrayList();
      maxVal = 0;
      String query = "select FLOOR(deweyClass/100)*100, count(case when itemtype like '%bk%' then ckoutDateTime end) book, count(case when itemtype like '%cd%' then ckoutDateTime end) cd,  count(case when itemtype like '%dvd%' then ckoutDateTime end) dvd, count(*) total from transactions2011 where deweyClass <> 'null' and month(ckoutDateTime) = "+ monthIndex + " group by FLOOR(deweyClass/100)*100 order by FLOOR(deweyClass/100)*100";
      println("Executing "+query);
      msql.query(query);
      
      while(msql.next()){
        if( Integer.parseInt(msql.getString(5)) > maxVal )
          maxVal = Integer.parseInt(msql.getString(5));
          
        String deweyName = resolveDeweyName(msql.getString(1));  
        
        deweyArray.add(new Dewey(deweyName, Integer.parseInt(msql.getString(2)), Integer.parseInt(msql.getString(3)), Integer.parseInt(msql.getString(4)), Integer.parseInt(msql.getString(5))));
      }
      monthArray.add(new Month(monthNames[monthIndex-1], deweyArray, maxVal));
      monthIndex++;
    }
  }
  else
    println("Connection Failed");
  
  for(int i = 0; i < monthArray.size();i++){
    Month m = (Month) monthArray.get(i);
    //println("Name "+m.name);
    //println("MaxVal "+m.maxVal);
    
    deweyArray = (ArrayList) m.deweyList;
    
    for(int j=0;j < deweyArray.size(); j++){
      Dewey d = (Dewey) deweyArray.get(j);
      //println("Dewey Class "+d.name);
      //println("Books "+d.book);
      //println("CDs "+d.cd);
      //println("DVDs "+d.dvd);
    }
    //println("------------------------");
    //println();
  }
}    
        
